<template>
  <v-menu
    bottom
    left
    min-width="200"
    offset-y
    origin="top right"
    transition="scale-transition"
  >
    <template v-slot:activator="{ attrs, on }">
      <v-btn
        class="ml-2"
        min-width="0"
        text
        v-bind="attrs"
        v-on="on"
      >
        <v-icon>mdi-calendar</v-icon>
      </v-btn>
    </template>

    <v-list
      :tile="false"
      flat
      nav
    >
      <template v-if="!isThereAPeriodToDisplay">
        <p class="my-0">
          <small>{{ $t('emptyList') }}</small>
        </p>
      </template>
      <template
        v-for="(p, i) in periods"
        v-else
      >
        <app-bar-item
          :key="`item-${i}`"
          input-value="active"
          :class="{ 'white--text secondary elevation-12': p.id === selectedPeriodId }"
        >
          <v-list-item-button
            @click="onClickPeriod(p)"
          >
            <p class="my-0 d-flex">
              <span class="mr-1">
                {{ p.title }}
              </span>
              <small class="d-flex align-self-center">
                ({{ p.startDate | formatDate }} - {{ p.endDate | formatDate }})
              </small>
            </p>
          </v-list-item-button>
        </app-bar-item>
      </template>
    </v-list>
  </v-menu>
</template>

<script>
  import DatesMixin from '@/mixins/date'

  export default {
    name: 'DefaultAccount',
    mixins: [DatesMixin],
    computed: {
      periods () {
        return this.$store.getters['periods/periodsToDisplay']
      },
      isThereAPeriodToDisplay () {
        return this.$store.getters['periods/isThereAPeriodToDisplay']
      },
      selectedPeriodId () {
        const selectedPeriod = this.$store.getters['periods/getSelectedPeriod']
        return selectedPeriod && selectedPeriod.id
          ? selectedPeriod.id
          : null
      },
    },
    methods: {
      onClickPeriod (period) {
        this.$store.dispatch('periods/setManuallySelectedPeriod', { period })
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          emptyList: 'Não há períodos selecionados para listar.',
        },
        'en-US': {
          emptyList: 'There are no selected periods to list.',
        },
      },
    },
  }
</script>
